package ru.dbotthepony.mc.otm.core.collect

import it.unimi.dsi.fastutil.Hash
import java.lang.ref.Reference

object ReferenceHashStrategy : Hash.Strategy<Any?> {
	@Suppress("UNCHECKED_CAST")
	override fun equals(a: Any?, b: Any?): Boolean {
		if (a === b) return true

		if (a is Reference<*>) {
			if (a.refersTo(null) || b == null) return false

			if (b is Reference<*>) {
				if (b.refersTo(null)) return false
				return (b as Reference<Any>).refersTo(a.get() ?: return false)
			} else {
				return (a as Reference<Any>).refersTo(b)
			}
		} else if (b is Reference<*>) {
			if (b.refersTo(null) || a == null) return false
			return (b as Reference<Any>).refersTo(a)
		}

		return a == b
	}

	override fun hashCode(o: Any?): Int {
		return o.hashCode()
	}
}
